/*global window, RSVP, console */
/*jslint nomen: true, indent: 2, maxerr: 3*/
(function (window, rJS, loopEventListener, jIO, mimeType) {
  "use strict";

  function addContent(gadget, event, logFunction) {
    var url = gadget.props.element.querySelector("form.crib-add .url").value,
        file_list = gadget.props.element.querySelector("form.crib-add .file")
                          .files,
        promise_list = [],
        file;
    if (logFunction === undefined) {
      logFunction = console.log;
    }
    if (file_list.length === 0) {
      logFunction("No File to Load");
      if (!url) {
        logFunction("Please Provide a File");
      }
      promise_list.push(
        gadget.crib_sw_put(url,
        {
          content: [],
          type: mimeType.lookup(url, false, "application/octet-stream")
        })
      );
    } else {
      if (!url || url.endsWith("/")) {
        url = url + file_list[0].name;
      }
      promise_list.push(
        gadget.crib_sw_put(url,
        {
          content: file_list[0],
          type: mimeType.lookup(url, false, "application/octet-stream")
        })
      );
    }
    return RSVP.Queue()
      .push(function () {
        return RSVP.all(promise_list);
      })
      .push(function () {
        return gadget.redirect({page: "editor", url: url});
      });
  }


  rJS(window)
    .ready(function (g) {
      g.props = {};
      return g.getElement()
        .push(function (element) {
          g.props.element = element;
          g.props.start_deferred = RSVP.defer();
        });
    })
    .declareAcquiredMethod("crib_sw_put", "crib_sw_put")
    .declareAcquiredMethod("redirect", "redirect")
    .declareMethod('render', function (options) {
      var gadget = this;
      if (options === undefined)
        options = {};
      gadget.props.options = options;
      if (options.url !== undefined) {
        gadget.props.element.querySelector("form.crib-add .url")
              .value = options.url;
      }
      return new RSVP.Queue()
        .push(function () {
          return gadget.props.start_deferred.resolve();
        });
    })
    .declareService(function () {
      var gadget = this;
      return new RSVP.Queue()
        .push(function () {
          return gadget.props.start_deferred.promise;
        })
        .push(function () {
          var promise_list = [];
          // promise to get content from URL
          promise_list.push(loopEventListener(
            gadget.props.element.querySelector(".crib-add"),
            'submit',
            false,
            function (event) {
              return addContent(gadget, event);
            }
          ));
          return RSVP.all(promise_list);
        });
    });
}(window, rJS, loopEventListener, jIO, mimeType));