/*jslint nomen: true, indent: 2, maxerr: 3 */
/*global window, rJS, Handlebars, document, loopEventListener, RSVP */
(function (window, rJS, document, RSVP) {
  "use strict";

  rJS(window)
    /////////////////////////////////////////////////////////////////
    // ready
    /////////////////////////////////////////////////////////////////

    // Assign the element to a variable
    .ready(function (g) {
      g.props = {};
      return g.getElement()
        .push(function (element) {
          g.props.element = element;
        });
    })
    //////////////////////////////////////////////
    // acquired methods
    //////////////////////////////////////////////
    .declareAcquiredMethod("getUrlFor", "getUrlFor")
    .declareAcquiredMethod("crib_sw_getScope", "crib_sw_getScope")
    .declareMethod('render', function (options) {
      var gadget = this,
        page_list = ["select_site", "jslint", "mass_remove", "grep",
                    "save_load", "crib_loader"],
        promise_list = [];

      page_list.forEach(function (page) {
        promise_list.push(gadget.getUrlFor({page: page}));
      });
      promise_list.push(gadget.crib_sw_getScope());
      // Handle main title
      return new RSVP.Queue()
        .push(function () {
          return RSVP.all(promise_list);
        })
        .push(function (link_list) {
          var url_list_scope_link = gadget.props.element
            .querySelector("a.url-list-scope");
          for (var i = 0; i < page_list.length; i++) {
            gadget.props.element.querySelector("." + page_list[i]).href = link_list[i];
          }
          gadget.props.scope = link_list[link_list.length - 1];
          url_list_scope_link.href = gadget.props.scope;
          url_list_scope_link.innerHTML = gadget.props.scope
            .split("//")[1].split(".")[0];
        });
    });


}(window, rJS, document, RSVP));